/**
*@METHOD		: Cities.cpp
*@DESCRIPTION	: Domain class definitions.
*@VERSION		: APRIL 1, 2015
*@PROGRAMMER	: BRIAN HINDS & JAMES SIMPSON
*
*/

#include "Cities.h"

/**
*@METHOD			:Cities
*@DESCRIPTION		:Extracts the data from the string into its correct
*@					:fields
*@PARAMETERS		:string _cityInformation
*@RETURNS			:None
*@
*/
Cities::Cities(string _cityInformation)
{
	/**
	*@ Prepares the data for extraction.
	*/
	stringstream cityStream(_cityInformation);
	/**
	*@ Extracting the data into correct fields.
	*/
	cityStream >> male;
	cityStream >> tMale;
	cityStream >> female;
	cityStream >> tFemale;
	cityStream >> cityName;
	cityStream >> province;
	/**
	*@ Getting the total population from data.
	*/
	GetPop(male, female, tMale, tFemale);

}
/**
*@METHOD			:GetPop
*@DESCRIPTION		:Summing the four categories to attain a total 
*@					:population
*@PARAMETERS		:int _male, int _female, int _teenMale, int _teenFemale
*@RETURNS			:None
*@
*/
void Cities::GetPop(int _male, int _female, int _teenMale, int _teenFemale)
{
	totalPop = _male + _female + _teenMale + _teenFemale;


}
/**
*@METHOD			:Cities
*@DESCRIPTION		:Default constructor.
*@PARAMETERS		:None
*@RETURNS			:none
*@
*/
Cities::Cities()
{

}
/**
*@METHOD			:GetMale
*@DESCRIPTION		:Returns the adult male population
*@PARAMETERS		:None
*@RETURNS			:male
*@
*/
int Cities::GetMale(void)
{
	return male;
}
/**
*@METHOD			:GetTeenMale
*@DESCRIPTION		:Returns the teen male population.
*@PARAMETERS		:None
*@RETURNS			:tMale
*@
*/
int Cities::GetTeenMale(void)
{
	return tMale;
}
/**
*@METHOD			:GetFemale
*@DESCRIPTION		:Returns the adult female population
*@PARAMETERS		:None
*@RETURNS			:female
*@
*/
int Cities::GetFemale(void)
{
	return female;
}
/**
*@METHOD			:GetTeenFemale
*@DESCRIPTION		:Returns the teen female population.
*@PARAMETERS		:None
*@RETURNS			:tFemale
*@
*/
int Cities::GetTeenFemale(void)
{
	return tFemale;
}
/**
*@METHOD			:GetCity
*@DESCRIPTION		:Returns the city name
*@PARAMETERS		:None
*@RETURNS			:cityName
*@
*/
string Cities::GetCity(void)
{
	return cityName;
}
/**
*@METHOD			:GetProvince
*@DESCRIPTION		:Returns the province name.
*@PARAMETERS		:None
*@RETURNS			:province
*@
*/
string Cities::GetProvince(void)
{
	return province;
}
 
/**
*@METHOD			:GetTotalPop
*@DESCRIPTION		:Returns the value of total population.
*@PARAMETERS		:None
*@RETURNS			:totalPop
*@
*/
int Cities::GetTotalPop(void)
{
	return totalPop;
}
/**
*@METHOD			:~Cities
*@DESCRIPTION		:Frees memory
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
Cities::~Cities()
{
}
