/**
*@METHOD		: CityPopulation.cpp
*@DESCRIPTION	: Container class definitions.
*@VERSION		: APRIL 1, 2015
*@PROGRAMMER	: BRIAN HINDS & JAMES SIMPSON
*
*/

#include "CityPopulation.h"
#include "Menu.h"

/**
*@METHOD			:CityPopulation
*@DESCRIPTION		:Streams input data base, insert, and sort data.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
CityPopulation::CityPopulation(void) 
{
	
	/**
	*@ File to be read.
	*/
	ifstream cityfile("BrianHin.wopr");
	/**
	*@ Variable
	*/
	string cityInfo;
	loaded = 0;
	
	if (cityfile.is_open())
	{

		/**
		*@ Loop that extracts data base file.
		*/
		while (!cityfile.eof())
		{
			getline(cityfile, cityInfo);

			/**
			*@ Calling the extraction method from domain class.
			*/
			Cities record(cityInfo);
			/**
			*@ Pushing the new information into the container.
			*/
			population.push_back(record);
			loaded++;
		}
		cityfile.close();

		system("cls");
		/**
		*@ Sorts the container.
		*/
		sort(population.begin(), population.end(), [](Cities &record1, Cities &record2)
		{
			return record1.GetCity() < record2.GetCity();

		});
	}
	else
	{
		
		axisXY(0, 1); cout << "   <!> NO DATA BASE FILE HAS BEEN FOUND, NO RECORD WILL BE IN THE PROGRAM <!>  ";
		
		getchar();
	}
	
	axisXY(0, 1); cout << "       DATA BASE FILE LOADED SUCCESSFULLY. ENTRIES LOADED ARE: " << loaded << endl;
	
	
}
/**
*@METHOD			:construction
*@DESCRIPTION		: Construct user data for processing
*@PARAMETERS		:int _male, int _female, int _teenMale,
*@					:int _teenFemale, string _city, string _province
*@RETURNS			:None
*@
*/
void CityPopulation::Construction(int _male, int _female, int _teenMale, int _teenFemale, string _city, string _province)

{
	/**
	*@ Variable.
	*/
	string cityRecord = "";
	/**
	*@ Construction of data into a single string to be inserted into the container.
	*/
	stringstream custCity;
	custCity << _male << " " << _female << " " << _teenMale << " " << _teenFemale << " " << _city << " " << _province;
	cityRecord = custCity.str();
	/**
	*@ Calling the extraction method from domain class.
	*/
	Cities record(cityRecord);
	/**
	*@ Pushing the new information into the container.
	*/
	population.push_back(cityRecord);

	

}
/**
*@METHOD			:display
*@DESCRIPTION		:This method prints city population information.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::Display(void)
{
	/**
	*@ Variables
	*/
	string exit = "";
	unsigned int size = population.size();
	/**
	*@ Display loop.
	*/
	
	for (unsigned int i = 0; i < size; i++)
	{
	
		
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
			axisXY(40, 22); cout << "|=======================================|";
			axisXY(40, 23); cout << "|    City - " << population[i].GetCity() << "\t\t\n";
			axisXY(40, 24); cout << "|=======================================|";
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
			axisXY(40, 25); cout << "|=======================================|";
			axisXY(40, 26); cout << "|    Province               - \t" << population[i].GetProvince() << "\t|\n";
			axisXY(40, 27); cout << "|=======================================|";
			axisXY(40, 28); cout << "|    Male Population        - \t" << population[i].GetMale() << "\t|\n";
			axisXY(40, 29); cout << "|    Female Population      - \t" << population[i].GetFemale() << "\t|\n";
			axisXY(40, 30); cout << "|    Teen Male Population   - \t" << population[i].GetTeenMale() << "\t|\n";
			axisXY(40, 31); cout << "|    Teen Female Population - \t" << population[i].GetTeenFemale() << "\t|\n\n";
			axisXY(40, 32); cout << "|=======================================|";
			axisXY(40, 33); cout << "|    Total Population       - \t" << population[i].GetTotalPop() << "\t|\n";
			axisXY(40, 34); cout << "|=======================================|";
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
			axisXY(40, 15); cout << "|=======================================|\n";
			axisXY(40, 16); cout << "|[ENTER TO SCROLL] OR [X TO EXIT]:\t";
			axisXY(40, 17); cout << "|=======================================|\n";
			axisXY(75, 16); getline(cin, exit);
			/**
			*@ Exit condition.
			*/
			if (exit == "X" || exit == "x")
			{
				break;
			}
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
			axisXY(40, 23); cout << "                                          \n";
			
		
	}
	if (size == 0)
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 14);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[[SEARCH ERROR]:[295AF][ NO DATA ]]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[The data base is currently empty.]\n";
		axisXY(0, 26); cout << "[You can choose to add data by the]\n";
		axisXY(0, 27); cout << "[auto generation option or you may]\n";
		axisXY(0, 28); cout << "[manually enter population.       ]\n";
		axisXY(0, 29); cout << "|=================================|";
	}
	
}
/**
*@METHOD			:search
*@DESCRIPTION		:This method performs user define search for cities.
*@PARAMETERS		:(string _search)
*@RETURNS			:None
*@
*/
void CityPopulation::Search(string _search)
{
	/**
	*@ Variables
	*/


	unsigned int size = population.size();
	string userInput = _search;
	/**
	*@ Search loop
	*/

	for (unsigned int i = 0; i < size; i++)
	{
		if (userInput == population[i].GetCity())
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
			axisXY(40, 22); cout << "|=======================================|";
			axisXY(40, 23); cout << "|    City - " << population[i].GetCity() << "\t\t\n";
			axisXY(40, 24); cout << "|=======================================|";
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
			axisXY(40, 25); cout << "|=======================================|";
			axisXY(40, 26); cout << "|    Province               - \t" << population[i].GetProvince() << "\t|\n";
			axisXY(40, 27); cout << "|=======================================|";

			axisXY(40, 28); cout << "|    Male Population        - \t" << population[i].GetMale() << "\t|\n";
			axisXY(40, 29); cout << "|    Female Population      - \t" << population[i].GetFemale() << "\t|\n";
			axisXY(40, 30); cout << "|    Teen Male Population   - \t" << population[i].GetTeenMale() << "\t|\n";
			axisXY(40, 31); cout << "|    Teen Female Population - \t" << population[i].GetTeenFemale() << "\t|\n\n";
			axisXY(40, 32); cout << "|=======================================|";
			axisXY(40, 33); cout << "|    Total Population       - \t" << population[i].GetTotalPop() << "\t|\n";
			axisXY(40, 34); cout << "|=======================================|";
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
			return;
		}
	}
	/**
	*@ Condition if information not found.
	*/
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 14);
	axisXY(0, 22); cout << "|=================================|";
	axisXY(0, 23); cout << "[[SEARCH ERROR]:[295AF][ NO DATA] ]\n";
	axisXY(0, 24); cout << "|=================================|";
	axisXY(0, 25); cout << "[The city you are searching for   ]\n";
	axisXY(0, 26); cout << "[is not found in our system. Press]\n";
	axisXY(0, 27); cout << "[enter to clear error and perform ]\n";
	axisXY(0, 28); cout << "[your search again. Please not    ]\n";
	axisXY(0, 29); cout << "[That is field is case sensitive. ]";
	axisXY(0, 30); cout << "|=================================|";
}
/**
*@METHOD			:addNewCityInput()
*@DESCRIPTION		:Takes in the user inputs for addNewCity.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::AddNewCityInput(void)
{
	int male = 0;
	int female = 0;
	int teenMale = 0;
	int teenFemale = 0;
	string city = "";
	string province = "";

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER THE CITY NAME YOU WISH TO ADD]: |";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	getline(cin, city);

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER THE PROVINCE YOU WISH TO ADD IT.]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	getline(cin, province);

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER ADULT MALE POPULATION NUMBER.   ]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	cin >> male;

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER ADULT FEMALE POPULATION NUMBER. ]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	cin >> female;

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER TEEN MALE POPULATION NUMBER.    ]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	cin >> teenMale;

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER TEEN FEMALE POPULATION NUMBER.  ]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	cin >> teenFemale;


	AddNewCity(male, female, teenMale, teenFemale, city, province);
}
/**
*@METHOD			:addNewCity()
*@DESCRIPTION		:Validates the user input for adding new population
*@PARAMETERS		:int _male, int _female, int _teenMale, int _teenFemale, string _city, string _province
*@RETURNS			:None
*@
*/
void CityPopulation::AddNewCity(int _male, int _female, int _teenMale, int _teenFemale, string _city, string _province)
{
	/**
	*@ Variables
	*/
	int male = _male;
	int female = _female;
	int teenMale = _teenMale;
	int teenFemale = _teenFemale;
	bool addInfo = true;
	string city = _city;
	string province = _province;
	string::size_type i = 0;
	string::size_type ib = 0;

	/**
	*@ Taking in user input
	*/
	
	/**
	*@ Validating city input from user.
	*/
	while ((i < city.length()) && (std::isalnum(city[i])))
	{
		++i;

	}
	if (i != city.length() || city.length() == 0 || city == "")
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
		axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
		axisXY(0, 27); cout << "[White space not allowed in city. ]\n";
		axisXY(0, 28); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
		axisXY(0, 29); cout << "|=================================|";
		addInfo = false;

	}
	/**
	*@ Taking in user input if previous validation passed.
	*/
	if (addInfo == true)
	{

		
		/**
		*@ Validating province input from user.
		*/
		while ((ib<province.length()) && (std::isalnum(province[ib])))
		{
			++ib;

		}

		if (ib != province.length() || province.length() == 0 || province == "" || province.length() > 2)
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
			axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
			axisXY(0, 27); cout << "[Must be the 2 letter province    ]\n";
			axisXY(0, 28); cout << "[abbreviation eg. ON, BC, or QB   ]\n";
			axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
			axisXY(0, 30); cout << "|=================================|";
			addInfo = false;

		}

	}
	/**
	*@ Taking in user input if previous validation passed.
	*/
	if (addInfo == true)
	{

		
	
		/**
		*@ Validating adult male population.
		*/
		if (male == 0 || cin.fail() || male > MAXPOP || male < MINPOP)
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
			axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
			axisXY(0, 27); cout << "[Must be below 500,000 population.]\n";
			axisXY(0, 28); cout << "[Must be above 15,000 population. ]\n";
			axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
			axisXY(0, 30); cout << "|=================================|";
			cin.clear();
			addInfo = false;
			
		}

	}
	/**
	*@ Taking in user input if previous validation passed.
	*/
	if (addInfo == true)
	{

		

		/**
		*@ Validating female population.
		*/
		if (female == 0 || cin.fail() || female > MAXPOP || female < MINPOP)
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
			axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
			axisXY(0, 27); cout << "[Must be below 500,000 population.]\n";
			axisXY(0, 28); cout << "[Must be above 15,000 population. ]\n";
			axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
			axisXY(0, 30); cout << "|=================================|";
			cin.clear();
			addInfo = false;
			
		}
	}
	/**
	*@ Taking in user input if previous validation passed.
	*/
	if (addInfo == true)
	{

		
		/**
		*@ Validating teen male population.
		*/
		if (teenMale == 0 || cin.fail() || teenMale > MAXPOP || teenMale < MINPOP)
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
			axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
			axisXY(0, 27); cout << "[Must be below 500,000 population.]\n";
			axisXY(0, 28); cout << "[Must be above 15,000 population. ]\n";
			axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
			axisXY(0, 30); cout << "|=================================|";
			cin.clear();
			addInfo = false;
			
		}

	}
	/**
	*@ Taking in user input if previous validation passed.
	*/
	if (addInfo == true)
	{

		
		/**
		*@ Validating teen female population.
		*/
		if (teenFemale == 0 || cin.fail() || teenFemale > MAXPOP || teenFemale < MINPOP)
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
			axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
			axisXY(0, 27); cout << "[Must be below 500,000 population.]\n";
			axisXY(0, 28); cout << "[Must be above 15,000 population. ]\n";
			axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
			axisXY(0, 30); cout << "|=================================|";
			cin.clear();
			addInfo = false;
			
		}

	}
	/**
	*@ Passing data off for construction if previous validation passed.
	*/
	if (addInfo == true)

	{
		/**
		*@ Passing records to extraction method for processing.
		*/
		Construction(male, female, teenMale, teenFemale, city, province);

		axisXY(0, 15); cout << "|=================================|";
		axisXY(0, 16); cout << "|    ADDING NEW CITY POPULATION   |";
		axisXY(0, 17); cout << "|=========== SUCCESSFUL===========|";
		axisXY(0, 18); cout << "|====[PRESS ENTER TO CONTINUE]====|";

		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|    City - " << city << "\t\t\n";
		axisXY(40, 24); cout << "|=======================================|";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
		axisXY(40, 25); cout << "|=======================================|";
		axisXY(40, 26); cout << "|    Province               - \t" << province << "\t|\n";
		axisXY(40, 27); cout << "|=======================================|";

		axisXY(40, 28); cout << "|    Male Population        - \t" << male << "\t|\n";
		axisXY(40, 29); cout << "|    Female Population      - \t" << female << "\t|\n";
		axisXY(40, 30); cout << "|    Teen Male Population   - \t" << teenMale << "\t|\n";
		axisXY(40, 31); cout << "|    Teen Female Population - \t" << teenFemale << "\t|\n\n";
		axisXY(40, 32); cout << "|=======================================|";
		axisXY(40, 33); cout << "|    Total Population       - \t" << male + female + teenMale + teenFemale << "\t|\n";
		axisXY(40, 34); cout << "|=======================================|";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
		
	}
getchar();
}

/**
*@METHOD			:cityInput
*@DESCRIPTION		:Takes in city name from the user.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::CityInput(void)
{
	string city = "";
	
	/**
	*@ City input from user.
	*/
	axisXY(40, 15); cout << "|=======================================|";
	axisXY(40, 16); cout << "|[ENTER A CITY NAME TO SEARCH]:\t";
	axisXY(40, 17); cout << "|=======================================|";
	axisXY(40, 18); cout << "|->";
	axisXY(43, 18);	getline(cin, city);

	CityVal(city);

}
/**
*@METHOD			:cityVal
*@DESCRIPTION		:Validates user input for correct province format
*@PARAMETERS		:string _city
*@RETURNS			:None
*@
*/
void CityPopulation::CityVal(string _city)
{
	
	/**
	*@ Validation  of city.
	*/
	if (_city.length() == 0 || _city == "")
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[You have not entered a city name ]\n";
		axisXY(0, 26); cout << "[on the user input line. Press    ]\n";
		axisXY(0, 27); cout << "[enter to clear error and perform ]\n";
		axisXY(0, 28); cout << "[your search again.               ]\n";
		axisXY(0, 29); cout << "|=================================|";
		
	}
	else
	/**
	*@ If validation is a success then the search commence.
	*/
	{
		Search(_city);

	}


}

/**
*@METHOD			:GenInput()
*@DESCRIPTION		:Generates user define input for random records.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::GenInput(void)
{
	int generate = 0;
	
	/**
	*@ User input for define amount of generated items.
	*/
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[HOW MANY ENTRIES YOU WISH TO GENERATE?]";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                       ";
	axisXY(43, 18); cin >> generate;
	Generate(generate);

	


}

/**
*@METHOD			:generate()
*@DESCRIPTION		:Validates Generates user define random records.
*@PARAMETERS		:(int _input)
*@RETURNS			:None
*@
*/
void CityPopulation::Generate(int _input)
{
	/**
	*@ Variables
	*/
	
	int nCount = 0;
	bool addInfo = true;
	string confirm = "";
	/**
	*@ Variables for city
	*/
	string city = "CustomCity-";
	string custCity = "";
	string newCity = "";
	/**
	*@ Variables for province
	*/
	string province = "CP-";
	string custProvine = "";
	string newProvince = "";
	cin.clear();


	if (_input > 1000)
	{


		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 14);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "|     [GENERATION WARINING]       |\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[Generating over 1000 entries will]\n";
		axisXY(0, 26); cout << "[be a slow process if the data    ]\n";
		axisXY(0, 27); cout << "[base is not empty. This process  ]\n";
		axisXY(0, 28); cout << "[generates and sorts with each new]\n";
		axisXY(0, 29); cout << "[entry, please confirm this task. ]\n";
		axisXY(0, 30); cout << "|=================================|";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
		axisXY(40, 15); cout << "|=======================================|\n";
		axisXY(40, 16); cout << "|[TYPE]:[YES] to generate [NO] to cancel|  ";
		axisXY(40, 17); cout << "|===========[THEN PRESS ENTER]==========|\n";
		axisXY(40, 18); cout << "|->                                       ";
		axisXY(43, 18); getchar();
		axisXY(43, 18); getline(cin, confirm);

		
		if (confirm == "yes" || confirm == "Yes" || confirm == "YES")
		{
			addInfo = true;
		}
		else if (confirm == "no" || confirm == "No" || confirm == "NO")
		{
			addInfo = false;
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
			axisXY(0, 22); cout << "|=================================|";
			axisXY(0, 23); cout << "|     [GENERATION WARINING]       |\n";
			axisXY(0, 24); cout << "|=================================|";
			axisXY(0, 25); cout << "[Generating task have been averted]\n";
			axisXY(0, 26); cout << "[by the user. No new records have ]\n";
			axisXY(0, 27); cout << "[been generated or added to the   ]\n";
			axisXY(0, 28); cout << "[current data base. Please press  ]\n";
			axisXY(0, 29); cout << "[enter to return to main menu.    ]\n";
			axisXY(0, 30); cout << "|=================================|";
		}

	}

	/**
	*@ Validating generation input.
	*/
	if (_input <= 0 )
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[USAGE ERROR]:[245AF][INVALID DATA]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[Special characters not allowed.  ]\n";
		axisXY(0, 26); cout << "[Field cannot be empty.           ]\n";
		axisXY(0, 27); cout << "[Must be a number.                ]\n";
		axisXY(0, 28); cout << "[Must be above 0 generation.      ]\n";
		axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
		axisXY(0, 30); cout << "|=================================|";
		addInfo = false;
		_input = 0;
		cin.clear();
		getchar();
	}

	/**
	*@ Loop that generates random population.
	*/
	if (addInfo == true)
	{
		/**
		*@ Generation warning.
		*/		
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 13);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "|     [GENERATION WARINING]       |\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[Generating random city data will ]\n";
		axisXY(0, 26); cout << "[vary in the time it takes to     ]\n";
		axisXY(0, 27); cout << "[process the city data. If the    ]\n";
		axisXY(0, 28); cout << "[data base is already populated   ]\n";
		axisXY(0, 29); cout << "[with cities, process will be slow]\n";
		axisXY(0, 30); cout << "|=================================|";
		for (nCount = 0; nCount < _input; ++nCount)
		{
			/**
			*@ Syntax that creates a generated city.
			*/
			stringstream custCity;
			custCity << city << nCount;
			newCity = custCity.str();
			/**
			*@ Syntax that creates a generated province
			*/
			stringstream custProvince;
			custProvince << province << nCount;
			newProvince = custProvince.str();
			/**
			*@ Send the random data to be constructed for insertion.
			*/
			Construction(PRNG(), PRNG(), PRNG(), PRNG(), newCity, newProvince);
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 13);
			axisXY(40, 22); cout << "|=======================================|";
			axisXY(40, 23); cout << "|    GENERATION    TASK IN PROGRESS     |";
			axisXY(40, 24); cout << "|=======================================|";
			axisXY(40, 25); cout << " [GENERATION COMPLETED]=====[ " << nCount << endl;
			axisXY(40, 26); cout << " [TOTAL TO BE GENERATED]====[ " << _input << endl;
			
			
		}
			axisXY(40, 23); cout << "                                        ";			
		/**
		*@ Shows that generation task is complete and how much record has been generated.
		*/
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|Generation complete. Total: " << nCount;
		axisXY(40, 24); cout << "|=======================================|";
		axisXY(40, 25); cout << "|======= PRESS ENTER TO CONTINUE =======|";
		axisXY(40, 26); cout << "|=======================================|";
		
		getchar();
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	}
	/**
	*@ Sorts the container.
	*/
	sort(population.begin(), population.end(), [](Cities &record1, Cities &record2)
	{
		return record1.GetCity() < record2.GetCity();

	});

}
/**
*@METHOD			:PRNG()
*@DESCRIPTION		:Generates random numbers
*@PARAMETERS		:None
*@RETURNS			:unsigned nSeed % MAX
*@
*/
unsigned int CityPopulation::PRNG(void)
{
	/**
	*@ Initializing a starting seed.
	*/
	static unsigned int nSeed = SEED;

	/**
	*@ Using HIGH and LOW to calculate random numbers.
	*/
	nSeed = (HIGH * nSeed + LOW);

	/**
	*@ Generates numbers between 0 and MAX.
	*/
	return nSeed % MAX;
}
/**
*@METHOD			:saveFile()
*@DESCRIPTION		:Saves the current data base to a file.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::SaveFile(void)
{
	/**
	*@ Name of the file to save the data base.
	*/
	ofstream save("BrianHin.wopr");
	/**
	*@ Opening file for writing while checking if it is open.
	*/
	if (save.is_open())
	{
		unsigned int size = population.size();
		/**
		*@ Save loop.
		*/

		for (unsigned int i = 0; i < size; i++)
		{
			axisXY(40, 22); cout << "|=======================================|";
			axisXY(40, 23); cout << "|   SAVING  FILE IN PROGRESS...         |";
			axisXY(40, 24); cout << "|=======================================|";
			save << population[i].GetMale() << " " << population[i].GetFemale() << " "
			<< population[i].GetTeenMale() << " " << population[i].GetTeenFemale() << " "
			<< population[i].GetCity() << " " << population[i].GetProvince() << endl;
			
		}
		/**
		*@ Close file after writing
		*/
		save.close();
		/**
		*@ Confirm saving process is completed.
		*/
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|   SAVING  FILE COMPLETE...            |";
		axisXY(40, 24); cout << "|=======================================|";

	}
	/**
	*@ Condition executes if file is unable to be open for writing.
	*/
	else
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[USAGE ERROR]:[945AF][INVALID PATH]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[Unable to open file for saving.  ]\n";
		axisXY(0, 26); cout << "[Try the saving process again     ]\n";
		axisXY(0, 27); cout << "[                                 ]\n";
		axisXY(0, 28); cout << "[                                 ]\n";
		axisXY(0, 29); cout << "[PRESS ENTER TO RESTART THE ENTRY.]\n";
		axisXY(0, 30); cout << "|=================================|";

	}
}

/**
*@METHOD			:deleteCity()
*@DESCRIPTION		:Deletes a user specified city from the vector.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::DeleteCity(void)
{
	/**
	*@ Variables
	*/
	unsigned int size = population.size();
	string city = "";
	bool found = false;
	string exit = "";
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "|[ENTER THE CITY TO DEPOPULATE]:        |";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << "|->                                     ";
	axisXY(43, 18);	getline(cin, city);

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 14);
	axisXY(0, 22); cout << "|=================================|";
	axisXY(0, 23); cout << "[         !!USER WARNING!!        ]\n";
	axisXY(0, 24); cout << "|=================================|";
	axisXY(0, 25); cout << "[This process cannot be undone.   ]\n";
	axisXY(0, 26); cout << "[Performing this command will     ]\n";
	axisXY(0, 27); cout << "[erase a city  from the record    ]\n";
	axisXY(0, 28); cout << "[ Do you wish to continue?        ]\n";
	axisXY(0, 29); cout << "|=================================|";
	/**
	*@ User confirmation.
	*/
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "| [TYPE] [DELETE] OR [CANCEL]           |\n";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << ":                                          ";
	axisXY(43, 18); getline(cin, exit);
	/**
	*@ Confirming.
	*/
	if (exit == "DELETE" || exit == "delete" || exit=="Delete")
	{
		
		/**
		*@Search for and delete city
		*/
		for (unsigned int i = 0; i < size; i++)
		{
			if (city == population[i].GetCity())
			{
				population.erase(population.begin() + i);
				axisXY(40, 22); cout << "|=======================================|";
				axisXY(40, 23); cout << "| City has been depopulated             |";
				axisXY(40, 24); cout << "|=======================================|";
				found = true;
				break;
			}
			
			
		}
		/**
		*@ If city is not listed or already deleted
		*/
		 if (found == false)
		{
			axisXY(40, 22); cout << "|=======================================|";
			axisXY(40, 23); cout << "|            City Not found             |";
			axisXY(40, 24); cout << "|=======================================|";
		}
	}
	/**
	*@ Averting deletion process.
	*/
	if (exit == "CANCEL" || exit == "cancel" || exit =="Cancel")
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[         !!USER WARNING!!        ]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[You have chosen to cancel the    ]\n";
		axisXY(0, 26); cout << "[depopulate a city process.       ]\n";
		axisXY(0, 27); cout << "[No data have been lost or deleted]\n";
		axisXY(0, 28); cout << "[Press enter to continue.         ]\n";
		axisXY(0, 29); cout << "|=================================|";
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|  <!> Deletion process averted <!>     |";
		axisXY(40, 24); cout << "|=======================================|";
	}

	
}

/**
*@METHOD			:deleteAll()
*@DESCRIPTION		:Deletes every city from the container.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::DeleteAll(void)
{
	/**
	*@ Variables
	*/
	unsigned int size = population.size();
	string exit = "";

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 14);
	axisXY(0, 22); cout << "|=================================|";
	axisXY(0, 23); cout << "[         !!USER WARNING!!        ]\n";
	axisXY(0, 24); cout << "|=================================|";
	axisXY(0, 25); cout << "[This process cannot be undone.   ]\n";
	axisXY(0, 26); cout << "[Performing this command will     ]\n";
	axisXY(0, 27); cout << "[erase all life form from the     ]\n";
	axisXY(0, 28); cout << "[record. Do you wish to continue? ]\n";
	axisXY(0, 29); cout << "|=================================|";

	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "| [TYPE] [DELETE] OR [CANCEL]           |\n";
	axisXY(40, 17); cout << "|=======================================|\n";
	axisXY(40, 18); cout << ":";
	axisXY(43, 18); getline(cin, exit);
	/**
	*@ Confirming .
	*/
	if (exit == "DELETE" || exit == "delete")
	{
		/**
		*@ Delete everything stored in container
		*/
		population.clear();
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|<!> ALL LIFE FORM HAVE BEEN ERASED <!> |";
		axisXY(40, 24); cout << "|=======================================|";
	}
	/**
	*@ Averting.
	*/
	if (exit == "CANCEL" || exit == "cancel")
	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
		axisXY(0, 22); cout << "|=================================|";
		axisXY(0, 23); cout << "[         !!USER WARNING!!        ]\n";
		axisXY(0, 24); cout << "|=================================|";
		axisXY(0, 25); cout << "[You have chosen to cancel the    ]\n";
		axisXY(0, 26); cout << "[erase all life form process.     ]\n";
		axisXY(0, 27); cout << "[No data have been lost or deleted]\n";
		axisXY(0, 28); cout << "[Press enter to continue.         ]\n";
		axisXY(0, 29); cout << "|=================================|";
		axisXY(40, 22); cout << "|=======================================|";
		axisXY(40, 23); cout << "|  <!> Deletion process averted <!>     |";
		axisXY(40, 24); cout << "|=======================================|";
	}
		
}
/**
*@METHOD			:Help()
*@DESCRIPTION		:Displays help menu for user.
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/
void CityPopulation::Help(void)

{
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
	axisXY(40, 15); cout << "|=======================================|\n";
	axisXY(40, 16); cout << "| [PRESS ENTER TO SCROLL THE HELP MENU] |\n";
	axisXY(40, 17); cout << "|=======================================|\n";

	
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
	axisXY(40, 22); cout << "|=======================================|";
	axisXY(40, 23); cout << "|              HELP MENU 1/4            |";
	axisXY(40, 24); cout << "|=======================================|";
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
	axisXY(40, 25); cout << "|=======================================|";
	axisXY(40, 26); cout << "| OPERATION:                            |\n";
	axisXY(40, 27); cout << "|=======================================|";
	axisXY(40, 28); cout << "|-Do not close the program without exit.|\n";
	axisXY(40, 29); cout << "|doing so will not revert your PC       |\n";
	axisXY(40, 30); cout << "|settings back to normal console setting|\n";
	axisXY(40, 31); cout << "|-Avoid trolling arrow keys in the menu.|\n";
	axisXY(40, 32); cout << "|=======================================|";
	axisXY(40, 33); cout << "| PLEASE COMPLY WITH INPUT INSTRUCTION  |";
	axisXY(40, 34); cout << "|=======================================|";
	getchar();
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
	axisXY(40, 22); cout << "|=======================================|";
	axisXY(40, 23); cout << "|              HELP MENU 2/4            |";
	axisXY(40, 24); cout << "|=======================================|";
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
	axisXY(40, 25); cout << "|=======================================|";
	axisXY(40, 26); cout << "| INPUTS:                               |\n";
	axisXY(40, 27); cout << "|=======================================|";
	axisXY(40, 28); cout << "|-Do not use enter key on empty fields. |\n";
	axisXY(40, 29); cout << "|-Correct data in correct fields only.  |\n";
	axisXY(40, 30); cout << "|-Each population field is 500k max.    |\n";
	axisXY(40, 31); cout << "|-Add a city also creates a new province|\n";
	axisXY(40, 32); cout << "|=======================================|";
	axisXY(40, 33); cout << "| PLEASE COMPLY WITH INPUT INSTRUCTION  |";
	axisXY(40, 34); cout << "|=======================================|";
	getchar();
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
	axisXY(40, 22); cout << "|=======================================|";
	axisXY(40, 23); cout << "|              HELP MENU 3/4            |";
	axisXY(40, 24); cout << "|=======================================|";
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
	axisXY(40, 25); cout << "|=======================================|";
	axisXY(40, 26); cout << "| DEPOPULATING:                         |\n";
	axisXY(40, 27); cout << "|=======================================|";
	axisXY(40, 28); cout << "|-Delete populations are irreversible.  |\n";
	axisXY(40, 29); cout << "|-You can only delete one or all records|\n";
	axisXY(40, 30); cout << "|-Leaving field empty auto averts task. |\n";
	axisXY(40, 31); cout << "|-Do not use enter key on empty fields. |\n";
	axisXY(40, 32); cout << "|=======================================|";
	axisXY(40, 33); cout << "| PLEASE COMPLY WITH INPUT INSTRUCTION  |";
	axisXY(40, 34); cout << "|=======================================|";
	getchar();
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 11);
	axisXY(40, 22); cout << "|=======================================|";
	axisXY(40, 23); cout << "|              HELP MENU 4/4            |";
	axisXY(40, 24); cout << "|=======================================|";
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
	axisXY(40, 25); cout << "|=======================================|";
	axisXY(40, 26); cout << "| GENERATING:                           |\n";
	axisXY(40, 27); cout << "|=======================================|";
	axisXY(40, 28); cout << "|-Process is slower on a used data base.|\n";
	axisXY(40, 29); cout << "|-Do not use enter key during generation|\n";
	axisXY(40, 30); cout << "|-Process sorts while generating entries|\n";
	axisXY(40, 31); cout << "|-Avoid generating obscure amount.      |\n";
	axisXY(40, 32); cout << "|=======================================|";
	axisXY(40, 33); cout << "| PLEASE COMPLY WITH INPUT INSTRUCTION  |";
	axisXY(40, 34); cout << "|=======================================|";

		
	
}
/**
*@METHOD			:~CityPopulation
*@DESCRIPTION		:Free memory
*@PARAMETERS		:None
*@RETURNS			:None
*@
*/

CityPopulation::~CityPopulation()
{
}
