/**
*@FILENAME		: CityPopulation.h
*@FUNCTION		: Population Class
*@DESCRIPTION	: The container class for the program.
*@VERSION		: APRIL 1, 2015
*@PROGRAMMER	: BRIAN HINDS & JAMES SIMPSON
*/


#include "Cities.h"
#include "Library.h"
using namespace std;

/**
*@ Constant Variables.
*/
#define SEED 5323
#define HIGH 8253729
#define LOW  2396403
#define MAX  499543
#define MAXPOP 500000
#define MINPOP 15000

#ifndef _CITYPOPULATION_H
#define _CITYPOPULATION_H

/**
*@ CityPopulation Class
*/

class CityPopulation : public Cities
{
	/**
	*@ PRIVATE
	*/
	private:
	/**
	*@ Container
	*/
	vector<Cities> population;
	
	int loaded;

	/**
	*@ PUBLIC
	*/ 
	public:


	/**
	*@ Constructor
	*/
	CityPopulation(string importFile);
	void Construction(int _male, int _female, int _teenMale, int _teenFemale, string _city, string _province);
	/**
	*@ Default constructor
	*/
	CityPopulation();

	/**
	*@ Methods
	*/
	
	void Help(void);
	void Display(void);
	void Search(string _search);
	void AddNewCityInput(void);

	void AddNewCity(int _male, int _female, int _teenMale, int _teenFemale, string _city, string _province);
	void GenInput(void);
	void Generate(int _input);
	void CityInput(void);
	void CityVal(string _city);
	void SaveFile(void);
	void DeleteCity(void);
	void DeleteAll(void);
	unsigned int PRNG(void);


	/**
	*2 Destructor
	*/
	~CityPopulation();
};
#endif
