/**
*@METHOD		: Menu.cpp
*@DESCRIPTION	: View layer file for the program.
*@VERSION		: APRIL 1, 2015
*@PROGRAMMER	: BRIAN HINDS & JAMES SIMPSON
*
*/
#include "Menu.h"
#include "CityPopulation.h"

/**
*@METHOD		:Default Constructor
*@DESCRIPTION	:-----
*@PARAMETERS	:None
*@RETURNS		:None
*@
*/
Menu::Menu()
{
}

/**
*@METHOD		:RunMenu
*@DESCRIPTION	:Main menu for the program.
*@PARAMETERS	:CityPopulation* a; pointer to the container
*@RETURNS		:None
*@
*/
int Menu::RunMenu(CityPopulation* a)
{
	theContainer = a;
	/**
	*@ Remove blinking cursor from the menu screen.
	*/
	ChangeCursorStatus(false);
	/**
	*@ Menu layer one variables.
	*/
	menu_item = 0;
	x = 4;
	running = true;

	/**
	*@ Default position for arrow key for menu.
	*/
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);
	axisXY(0, 4); cout << "  ->";
	/**
	*@ Menu while loop for view layer.
	*/
	while (running)
	{

		/**
		*@ GUI for the view layer.
		*/
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 30);
		axisXY(0, 0); cout << "|===============================================================================|\n";
		axisXY(0, 1); cout << "|[[:SYSTEM:]] - WAR OPERATION PLAN RESPONSE [WOPR]\t  [[:COUNTRY:]] - CANADA|";
		axisXY(0, 2); cout << "|===============================================================================|\n";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 27);
		axisXY(0, 3);  cout << "|================= MAIN MENU ===========|---------------------------------------|\n";
		axisXY(5, 4);  cout << "[1] POPULATE\t\t\t|Use Up and Dwn arrow keys to navigate  |";
		axisXY(5, 5);  cout << "[2] GENERATE\t\t\t|then press ENTER to make  selection.   |";
		axisXY(5, 6);  cout << "[3] DEPOPULATE\t\t\t|---------------------------------------|";
		axisXY(5, 7); cout << "[4] DISPLAY\t\t\t|";
		axisXY(5, 8); cout << "[5] SEARCH\t\t\t\t|";
		axisXY(5, 9); cout << "[6] HELP\t\t\t\t|";
		axisXY(5, 10); cout << "[7] EXIT\t\t\t\t|";
		axisXY(0, 11);  cout << "|=======================================|\n";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 24);
		axisXY(0, 12);  cout << "|=================================|\n";
		axisXY(0, 13);  cout << "|== OPERATION SELECTED IS BELOW ==|\n";
		axisXY(0, 14);  cout << "|=================================|\n";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 24);
		axisXY(40, 12);  cout << "|=======================================|\n";
		axisXY(40, 13);  cout << "|======= EXECUTING SELECTED BELOW ======|\n";
		axisXY(40, 14);  cout << "|=======================================|\n";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 24);
		axisXY(0, 19);  cout << "|=================================|";
		axisXY(0, 20);  cout << "|==== <!>ERROR PANEL BELOW<!> ====|";
		axisXY(0, 21);  cout << "|=================================|";
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 24);
		axisXY(40, 19);  cout << "|=======================================|";
		axisXY(40, 20);  cout << "|======= DATA DISPLAY PANEL BELOW ======|";
		axisXY(40, 21);  cout << "|=======================================|";
		axisXY(0, 35); cout << "|===============================================================================|\n";
		
		/**
		*@ Printing a nul bit in for the menu.
		*/
		system("pause>nul");

		/**
		*@ This section determine the menu option through keystroke.
		*/
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 12);

		/**
		*@ The section increments menu option when down key is pressed.
		*/
		if (GetAsyncKeyState(VK_DOWN) && x != 10)
		{
			axisXY(2, x); cout << "  ";
			x++;
			Beep(550, 200);
			axisXY(2, x); cout << "->";
			menu_item++;
			continue;

		}
		/**
		*@ This section decrements the menu option when the up key is pressed.
		*/
		if (GetAsyncKeyState(VK_UP) && x != 4)
		{
			axisXY(2, x); cout << "  ";
			x--;
			Beep(550, 200);
			axisXY(2, x); cout << "->";
			menu_item--;
			continue;
		}
		/**
		*@ This section detects when the enter key is pressed.
		*/
		if (GetAsyncKeyState(VK_RETURN))
		{
			SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
			Beep(600, 500);
			/**
			*@ This switch case is for view layer level one.
			*/
			switch (menu_item)
			{

				case 0:
				{

						  /**
						  *@ This menu option allow user to add a city and population.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "| ADD A NEW CITY AND POPULATION   |";
						  axisXY(0, 17);  cout << "|          PRESS ENTER            |";
						  axisXY(0, 18);  cout << "|=================================|";
						  getchar();
						  theContainer->AddNewCityInput();
						  getchar();
						  system("cls");
						  axisXY(2, 4); cout << "->";
						  break;
				}

				case 1:
				{
						  /**
						  *@ This menu option allow the user to generate random data.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "| GENERATE RANDOM POPUTATION DATA |";
						  axisXY(0, 17);  cout << "|           PRESS ENTER           |";
						  axisXY(0, 18);  cout << "|=================================|";
						  getchar();
						  theContainer->GenInput();
						  getchar();
						  system("cls");
						  axisXY(2, 5); cout << "->";
						  break;
				}

				case 2:
				{
						  /**
						  *@ Sub menu variables.
						  */
						  axisXY(20, 16);
						  menu_itemb = 0;
						  xb = 8;
						  axisXY(42, 8); cout << "->";

						  /**
						  *@ Sub menu while loop.
						  */
						  while (running)
						  {
							  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 23);
							  /**
							  *@ Sub menu GUI.
							  */
							  axisXY(41, 7);  cout << "================== SUB MENU ===========|\n";
							  axisXY(45, 8);  cout << "[1] DEPOPULATE A CITY\t\t|";
							  axisXY(45, 9);  cout << "[2] DEPOPULATE THE COUNTRY\t\t|";
							  axisXY(45, 10);  cout << "[3] CANCEL DEPOPULATION PROCESS\t|";
							  axisXY(41, 11);  cout << "=======================================|\n";

							  /**
							  *@ Printing a nul bit in for the menu.
							  */
							  system("pause>nul");

							  /**
							  *@ The section increments menu option when down key is pressed.
							  */
							  if (GetAsyncKeyState(VK_DOWN) && xb != 10)
							  {
								  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
								  axisXY(42, xb); cout << "  ";
								  xb++;
								  Beep(550, 200);
								  axisXY(42, xb); cout << "->";
								  menu_itemb++;
								  continue;
								  
							  }
							  /**
							  *@ This section decrements the menu option when the up key is pressed.
							  */
							  if (GetAsyncKeyState(VK_UP) && xb != 8)
							  {
								  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
								  axisXY(42, xb); cout << "  ";
								  xb--;
								  Beep(550, 200);
								  axisXY(42, xb); cout << "->";
								  menu_itemb--;
								  continue;
							  }
							  /**
							  *@ This section detects when the enter key is pressed.
							  */
							  if (GetAsyncKeyState(VK_RETURN))
							  {
								  Beep(600, 500);
								  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);

								  /**
								  *@ This switch case is for view layer level two.
								  */
								  switch (menu_itemb)
								  {

									  case 0:
									  {
												/**
												*@ View layer two sub menu search and delete a city option.
												*/
												axisXY(5, 20);
												axisXY(0, 15);  cout << "|=================================|";
												axisXY(0, 16);  cout << "| TO SEARCH AND DEPOPULATE A CITY |";
												axisXY(0, 17);  cout << "|           PRESS ENTER           |";
												axisXY(0, 18);  cout << "|=================================|";
												getchar();
												theContainer->DeleteCity();
												getchar();
												system("cls");
												axisXY(2, 6); cout << "->";
												break;
									  }


									  case 1:
									  {
												/**
												*@ View layer two sub menu delete all population option. 
												*/
												axisXY(5, 20);
												axisXY(0, 15);  cout << "|=================================|";
												axisXY(0, 16);  cout << "| TO DEPOPULATE THE ENTIRE COUNTRY|";
												axisXY(0, 17);  cout << "|           PRESS ENTER           |";
												axisXY(0, 18);  cout << "|=================================|";
												getchar();
												theContainer->DeleteAll();
												getchar();
												system("cls");
												axisXY(2, 6); cout << "->";
												break;
									  }

									  case 2:
									  {
												/**
												*@ View layer two sub menu cancel depopulation options.
												*/
												axisXY(5, 20);
												axisXY(0, 15);  cout << "|=================================|";
												axisXY(0, 16);  cout << "|  DEPOPULATION OPTION CANCELED   |";
												axisXY(0, 17);  cout << "|  PRESS ENTER TO RETURN TO MAIN  |";
												axisXY(0, 18);  cout << "|=================================|";
												getchar();
												system("cls");
												axisXY(2, 6); cout << "->";
												break;
									  }

									  break;
								  }
								  break;
							  }

						  }


						  break;
				}

				case 3:
				{
						  /**
						  *@ View layer one, to display current population data.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "| DISPLAY CURRENT POPULATION DATA |";
						  axisXY(0, 17);  cout << "|            PRESS ENTER          |";
						  axisXY(0, 18);  cout << "|=================================|";;
						  getchar();
						  theContainer->Display();
						  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);						  
						  system("cls");
						  axisXY(2, 7); cout << "->";

						  break;
				}

				case 4:
				{
						  /**
						  *@ View layer one, search and display a city population.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "|TO SEARCH A CITY POPULATION DATA |";
						  axisXY(0, 17);  cout << "|           PRESS ENTER           |";
						  axisXY(0, 18);  cout << "|=================================|";;
						  getchar();
						  theContainer->CityInput();
						  getchar();
						  system("cls");
						  axisXY(2, 8); cout << "->";
						  break;
				}


				case 5:
				{
						  /**
						  *@ View layer one, save current population data to a file.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "|     THE HELP AND TIPS MENU      |";
						  axisXY(0, 17);  cout << "|           PRESS ENTER           |";
						  axisXY(0, 18);  cout << "|=================================|";;;
						  getchar();
						  theContainer->Help();
						  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), 10);
						  getchar();
						  system("cls");
						  axisXY(2, 9); cout << "->";
						  break;
				}



				case 6:
				{
						  /**
						  *@ View layer one, save and exit program.
						  */
						  axisXY(20, 16);
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "|      TO SAVE FILE AND EXIT      |";
						  axisXY(0, 17);  cout << "|           PRESS ENTER           |";
						  axisXY(0, 18);  cout << "|=================================|";;
						  getchar();
						  theContainer->SaveFile();
						  axisXY(0, 15);  cout << "|=================================|";
						  axisXY(0, 16);  cout << "|         SHUTTING DOWN           |";
						  axisXY(0, 17);  cout << "|          PLEASE WAIT!           |";
						  axisXY(0, 18);  cout << "|=================================|";;
						  Sleep(1000);
						  running = false;
				}



			}

		}

	}

	axisXY(20, 21);
	return 0;



}



/**
*@METHOD			:SetBoothUp()
*@DESCRIPTION		:Sets the console settings needed for the program.
*@PARAMETERS		:None
*@RETURNS			:None
*@=
*/
void Menu::SetBoothUp()
{

	/**
	*@ Variables.
	*/
	j = 0;
	i = 0;
	Width = 81;
	Height = 38;

	/**
	*@ Color of loading bar and text.
	*/
	system("color 0b");
	axisXY(40, 12); cout << "\n\n\n\t\t\tCONFIGURING CONSOLE WINDOW\n\n";

	/**
	*@ Draws loading bar shadow.
	*/
	cout << "\t\t\t";
	for (i = 0; i <= 25; i++)
		cout << (char)177;
	/**
	*@ Setting window size for the program menu.
	*/
	_COORD coord;
	coord.X = Width;
	coord.Y = Height;

	_SMALL_RECT Rect;
	Rect.Top = 0;
	Rect.Left = 0;
	Rect.Bottom = Height - 1;
	Rect.Right = Width - 1;

	HANDLE Handle = GetStdHandle(STD_OUTPUT_HANDLE);      ///< Get Handle 
	SetConsoleScreenBufferSize(Handle, coord);            ///< Set Buffer Size 
	SetConsoleWindowInfo(Handle, TRUE, &Rect);            ///< Set Window Size 
	/**
	*@ Loops and draw the loading bar.
	*/
	cout << "\r";
	cout << "\t\t\t";
	for (i = 0; i <= 25; i++)
	{
		cout << (char)219;
		for (j = 0; j <= 1e8; j++);
	}
	system("cls");


}

/**
*@METHOD			:SetShutDown()
*@DESCRIPTION		:Set console window size and color to its default.
*@PARAMETERS		:None
*@RETURNS			:None
*@=
*/
void Menu::SetShutDown()
{
	/**
	*@ Variables.
	*/
	j = 0;
	i = 0;	
	Width = 80;
	Height = 25;

	/**
	*@ Color of loading bar and text.
	*/
	system("color 0a");
	axisXY(15, 12); cout << "\n\n\n\t\tPLEASE WAIT, REVERTING SYSTEM TO ORIGINAL SETTINGS.\n\n";
	/**
	*@ Draws loading bar shadow.
	*/
	cout << "\t\t";
	for (i = 0; i <= 49; i++)
		cout << (char)177;
	/**
	*@ Adjust the window size to default
	*/
	_COORD coord;
	coord.X = Width;
	coord.Y = Height;

	_SMALL_RECT Rect;
	Rect.Top = 0;
	Rect.Left = 0;
	Rect.Bottom = Height - 1;
	Rect.Right = Width - 1;

	HANDLE Handle = GetStdHandle(STD_OUTPUT_HANDLE);      ///< Get Handle 
	SetConsoleScreenBufferSize(Handle, coord);            ///< Set Buffer Size 
	SetConsoleWindowInfo(Handle, TRUE, &Rect);            ///< Set Window Size 
	/**
	*@ Loops and draw the loading bar.
	*/
	cout << "\r";
	cout << "\t\t";
	for (i = 0; i <= 49; i++)
	{
		cout << (char)219;
		for (j = 0; j <= 1e8; j++);
	}

	system("cls");
	cout << "\n\n\n\t\t\tYOU MAY NOW POWER OFF THIS CONSOLE\n\n";
	system("color 07");
	getchar();
}


/**
*@FUNCTION		:axisXY
*@DESCRIPTION	:Maps the X Y position of items for the GUI menu.
*@PARAMETERS	:int x, int y
*@RETURNS		:None
*@
*/
void axisXY(int x, int y)
{
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	COORD CursorPosition;


	CursorPosition.X = x;
	CursorPosition.Y = y;
	SetConsoleCursorPosition(console, CursorPosition);
}
/**
*@FUNCTION			:ChangeCursorStatus
*@DESCRIPTION		:Windows handle for the cursor.
*@PARAMETERS		:(bool Visible)
*@RETURN			:none
*@=
*/
void ChangeCursorStatus(bool Visible)
{
	CONSOLE_CURSOR_INFO *cursor = new CONSOLE_CURSOR_INFO;
	HANDLE buffer = GetStdHandle(STD_OUTPUT_HANDLE);

	if (Visible)
	{
		cursor->bVisible = TRUE;
		/**
		*@ 0 is not valid so a default is set.
		*/
		cursor->dwSize = 0;
	}
	else
	{
		cursor->bVisible = FALSE;
		/**
		*@ assigned to a valid value.
		*/
		cursor->dwSize = 1;
	}

	SetConsoleCursorInfo(buffer, cursor);
}
/**
*@METHOD		:Destructor
*@DESCRIPTION	:Free memory
*@PARAMETERS	:None
*@RETURNS		:None
*@
*/
Menu::~Menu()
{
}
